package org.btcollider.cnc;

import java.util.concurrent.TimeUnit;
import org.btcollider.cnc.comm.CommException;
import org.btcollider.cnc.comm.CommServer;
import org.btcollider.cnc.keysrv.KSFactory;
import org.btcollider.cnc.keysrv.KeyServer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Hello world!
 *
 */
public class CnC {
  static final Logger log = LoggerFactory.getLogger(CnC.class);

  public static final int PORT = 26765;
  // Invariant: positive long (2^63-1) must be able to hold all bits handled here
  public static final int MAX_BITS = 62;

  public static void main(String[] args) {
    KeyServer kts = KSFactory.build(54, 30, 90, TimeUnit.MINUTES, 0.62f);
    CommServer server = new CommServer(PORT, kts);
    try {
      server.listen();
    } catch (CommException e) {
      log.error("CommServer couldn't be started", e);
    } finally {
      server.stop();
    }
  }
}
